QGIS Application - Feature request #3284
Wrapping long labels
2010-12-02 08:20 AM - Michael Douchin

Status: Closed

Priority: Low

Assignee: Nathan Woodrow

Category: Labelling

Pull Request or Patch supplied: Resolution: fixed
Easy fix?: No Copied to github as #: 13344
Description

Sometimes labels are very long, such as "River of the Big Dry Blue Reef". UMN Mapserver offers a way to wrap labels based on 2
parameters :

- amax length (integer)

- a wrap character, space by default

See http://mapserver.org/mapfile/label.html for more information.

| do not know how hard it is to implement this feature in the new label engine (considering curves, etc.)

Associated revisions

Revision f57892c7 - 2012-01-06 08:46 AM - Nathan Woodrow

[FEATURE] Add label wrapping on character. Semi Fixes #3284

History

#1 - 2011-02-10 06:49 PM - Alister Hood

| guess it would also be good if they could wrap to avoid collisions with features or other labels, instead of wrapping at a specified length :)

#2 - 2011-02-10 08:45 PM - Alister Hood

There is already a wrapping option.

But | have never figured out how to actually get layers to wrap. How is it supposed to work?

#3 - 2011-02-10 09:03 PM - Alister Hood

There is already a wrapping option. But | have never figured out how to actually get layers to wrap. How is it supposed to work?

Oh, | remember now. The User Guide says multiline labels work with a true line return. I'm not sure how you're supposed to enter a true line return though

(on windows).

#4 - 2011-02-10 10:16 PM - Alister Hood
Aha, here's the answer from the mailing list:
You have to enter a "real" newline. If you want to enter multiline labels in

QGIS you need to assign a [[TextEdit]] instead of [[LineEdit]] as edit widget in the
vector layer properties’ attributes tab.

Of course this feature request is still valid, as it is about automatic wrapping, not wrapping with a manual line break.

#5 - 2011-11-12 06:13 AM - Michael Douchin

I think this request if no longer needed since the implementation of expression based labelling :
http://woostuff.wordpress.com/2011/10/27/expression-based-labeling/

#6 - 2011-11-12 06:18 AM - Nathan Woodrow
- Pull Request or Patch supplied set to No
- Assignee deleted (nobody -)

I wouldn't close it just yet as the expression labeling thing doesn't really expose a function to wrap strings. It's on the todo list and shouldn't be to hard to
add.

#7 - 2011-12-16 01:49 PM - Giovanni Manghi

- Target version changed from Version 1.7.0 to Version 1.7.4

#8 - 2012-01-05 11:47 PM - Anonymous

- % Done changed from 0 to 100
- Status changed from Open to Closed

Fixed in changeset commit:"f57892c73d8a3b4a3abe4b8659369720e9cc1329".

#9 - 2012-01-05 11:50 PM - Nathan Woodrow

- Resolution set to fixed

- Category changed from Map Canvas to Labelling
- Assignee set to Nathan Woodrow

| have added the ability to wrap labels based on a character, check on the advanced tab on the label dialog. Max length isn't done yet but it shouldn't be
too hard to add.

#10 - 2012-01-06 12:22 AM - Michael Douchin

Nathan Woodrow wrote:

I have added the ability to wrap labels based on a character, check on the advanced tab on the label dialog. Max length isn't done yet but it
shouldn't be too hard to add.
Thanks !

#11 - 2012-01-06 02:51 AM - Nathan Woodrow

How would you like max length handled. | was just thinking of copying how MapServer does it http://mapserver.org/mapfile/label.html#maxlength

#12 - 2012-01-06 04:49 AM - Michael Douchin

| think it makes sense. This way users won't have problem to use it if they come from mapserver.
Plus | think this is the easiest yet effective way to handle this issue

#13 - 2012-01-08 03:05 PM - Alister Hood

Nathan Woodrow wrote:

How would you like max length handled. | was just thinking of copying how MapServer does it http://mapserver.org/mapfile/label.html#maxlength

Just to clarify: are you proposing actually doing it in the expression builder?

#14 - 2012-01-08 03:15 PM - Alister Hood

While | can see the benefits of doing it the same way as other software, the mapserver way isn't particularly intuitive. Especially things like this:

If maxlength > 0 and wrap = ‘char’, insert a newline at the FIRST wrap character AFTER maxlength characters

| would think that users would expect it to wrap at the LAST wrap character BEFORE maxlength characters (assuming there is one).

And | don't see why they have two ways of achieving "hard wrap (always break at exactly MAXLENGTH characters)". Perhaps when there is "no wrap",

they mean to fruncate at MAXLENGTH characters, not to "hard wrap".

#15 - 2012-01-08 05:12 PM - Nathan Woodrow

Alister Hood wrote:

Just to clarify: are you proposing actually doing it in the expression builder?

No. The plan is to add another control to the label dialog for wrapping properties e.g. max length, wrap character etc

This is a general labeling thing not really just for expressions.
